<?xml version="1.0" encoding="UTF-8"?>

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:xmi="http://www.omg.org/XMI"
  xmlns:resources="http://www.ibm.com/websphere/appserver/schemas/5.0/resources.xmi"
  xmlns:resources.env="http://www.ibm.com/websphere/appserver/schemas/5.0/resources.env.xmi"
  xmlns:resources.j2c="http://www.ibm.com/websphere/appserver/schemas/5.0/resources.j2c.xmi"
  xmlns:resources.jdbc="http://www.ibm.com/websphere/appserver/schemas/5.0/resources.jdbc.xmi"
  xmlns:resources.jms="http://www.ibm.com/websphere/appserver/schemas/5.0/resources.jms.xmi"
  xmlns:resources.mail="http://www.ibm.com/websphere/appserver/schemas/5.0/resources.mail.xmi"
  xmlns:resources.url="http://www.ibm.com/websphere/appserver/schemas/5.0/resources.url.xmi"
  xmlns:scheduler="http://www.ibm.com/websphere/appserver/schemas/5.0/scheduler.xmi"
  xmlns:workmanager="http://www.ibm.com/websphere/appserver/schemas/5.0/workmanager.xmi">

<xsl:import href="copy.xsl"/>

<!-- resources -->

<!-- ConnectionFactory has changed, but lots of other elements have ConnectionFactory
     as its base type, so those also need to change. Since the XML Schemas have
     polymorphism and XSL does not, need to duplicate work here.

     resources:ConnectionFactory
         -> resources.j2c:J2CConnectionFactory
            -> resources.jdbc:CMPConnectionFactory
         -> resources.jdbc:DataSource
         -> resources.jdbc:JDBCProvider
         -> resources.jms:JMSConnectionFactory
         -> resources.jms:JMSProvider
-->
<!-- Defect 357348: make removal of diagnoseConnectionUsage property apply to all connection factories -->
<xsl:template match="factories/@diagnoseConnectionUsage"/>  <!--LI3816-38 -->

<!-- Defect 232876.1: remove providerType attribute -->
<!-- Defect 239035: remove xaRecoveryAuthAlias attribute -->
<xsl:template match="resources:ConnectionFactory/factories/preTestConfig"/>
<xsl:template match="resources:ConnectionFactory/factories/@manageCachedHandles"/>
<xsl:template match="resources:ConnectionFactory/factories/@logMissingTransactionContext"/>
<xsl:template match="resources:ConnectionFactory/factories/@xaRecoveryAuthAlias"/>
<xsl:template match="resources:ConnectionFactory/@providerType"/>
<xsl:template match="resources.j2c:J2CConnectionFactory/factories/preTestConfig"/>
<xsl:template match="resources.j2c:J2CConnectionFactory/factories/@manageCachedHandles"/>
<xsl:template match="resources.j2c:J2CConnectionFactory/factories/@logMissingTransactionContext"/>
<xsl:template match="resources.j2c:J2CConnectionFactory/factories/@xaRecoveryAuthAlias"/>
<xsl:template match="resources.j2c:J2CConnectionFactory/@providerType"/>
<xsl:template match="resources.j2c:J2CResourceAdapter/factories/preTestConfig"/>
<xsl:template match="resources.j2c:J2CResourceAdapter/factories/@manageCachedHandles"/>
<xsl:template match="resources.j2c:J2CResourceAdapter/factories/@logMissingTransactionContext"/>
<xsl:template match="resources.j2c:J2CResourceAdapter/factories/@xaRecoveryAuthAlias"/>
<xsl:template match="resources.j2c:J2CResourceAdapter/@providerType"/>
<xsl:template match="resources.jdbc:CMPConnectionFactory/factories/preTestConfig"/>
<xsl:template match="resources.jdbc:CMPConnectionFactory/factories/@manageCachedHandles"/>
<xsl:template match="resources.jdbc:CMPConnectionFactory/factories/@logMissingTransactionContext"/>
<xsl:template match="resources.jdbc:CMPConnectionFactory/factories/@xaRecoveryAuthAlias"/>
<xsl:template match="resources.jdbc:CMPConnectionFactory/@providerType"/>
<xsl:template match="resources.jdbc:JDBCProvider/factories/preTestConfig"/>
<xsl:template match="resources.jdbc:JDBCProvider/factories/@manageCachedHandles"/>
<xsl:template match="resources.jdbc:JDBCProvider/factories/@logMissingTransactionContext"/>
<xsl:template match="resources.jdbc:JDBCProvider/factories/@xaRecoveryAuthAlias"/>
<xsl:template match="resources.jdbc:JDBCProvider/@providerType"/>
<xsl:template match="resources.jdbc:DataSource/factories/preTestConfig"/>
<xsl:template match="resources.jdbc:DataSource/factories/@manageCachedHandles"/>
<xsl:template match="resources.jdbc:DataSource/factories/@logMissingTransactionContext"/>
<xsl:template match="resources.jdbc:DataSource/factories/@xaRecoveryAuthAlias"/>
<xsl:template match="resources.jdbc:DataSource/@providerType"/>
<xsl:template match="resources.jms:JMSConnectionFactory/factories/preTestConfig"/>
<xsl:template match="resources.jms:JMSConnectionFactory/factories/@manageCachedHandles"/>
<xsl:template match="resources.jms:JMSConnectionFactory/factories/@logMissingTransactionContext"/>
<xsl:template match="resources.jms:JMSConnectionFactory/factories/@xaRecoveryAuthAlias"/>
<xsl:template match="resources.jms:JMSConnectionFactory/@providerType"/>
<xsl:template match="resources.jms:JMSProvider/factories/preTestConfig"/>
<xsl:template match="resources.jms:JMSProvider/factories/@manageCachedHandles"/>
<xsl:template match="resources.jms:JMSProvider/factories/@logMissingTransactionContext"/>
<xsl:template match="resources.jms:JMSProvider/factories/@xaRecoveryAuthAlias"/>
<xsl:template match="resources.jms:JMSProvider/@providerType"/>

<!-- Delete all these elements/attributes from ConnectionPool -->
<xsl:template match="resources:ConnectionPool/numberOfSharedPoolPartitions"/>
<xsl:template match="resources:ConnectionPool/numberOfUnsharedPoolPartitions"/>
<xsl:template match="resources:ConnectionPool/numberOfFreePoolPartitions"/>
<xsl:template match="resources:ConnectionPool/freePoolDistributionTableSize"/>
<xsl:template match="resources:ConnectionPool/surgeThreshold"/>
<xsl:template match="resources:ConnectionPool/surgeCreationInterval"/>
<xsl:template match="resources:ConnectionPool/testConnection"/>
<xsl:template match="resources:ConnectionPool/testConnectionInterval"/>
<xsl:template match="resources:ConnectionPool/stuckTimerTime"/>
<xsl:template match="resources:ConnectionPool/stuckTime"/>
<xsl:template match="resources:ConnectionPool/stuckThreshold"/>
<xsl:template match="resources:ConnectionPool/properties"/>
<xsl:template match="resources:ConnectionPool/@numberOfSharedPoolPartitions"/>
<xsl:template match="resources:ConnectionPool/@numberOfUnsharedPoolPartitions"/>
<xsl:template match="resources:ConnectionPool/@numberOfFreePoolPartitions"/>
<xsl:template match="resources:ConnectionPool/@freePoolDistributionTableSize"/>
<xsl:template match="resources:ConnectionPool/@surgeThreshold"/>
<xsl:template match="resources:ConnectionPool/@surgeCreationInterval"/>
<xsl:template match="resources:ConnectionPool/@testConnection"/>
<xsl:template match="resources:ConnectionPool/@testConnectionInterval"/>
<xsl:template match="resources:ConnectionPool/@stuckTimerTime"/>
<xsl:template match="resources:ConnectionPool/@stuckTime"/>
<xsl:template match="resources:ConnectionPool/@stuckThreshold"/>

<xsl:template match="connectionPool/properties"/>
<xsl:template match="connectionPool/@numberOfSharedPoolPartitions"/>
<xsl:template match="connectionPool/@numberOfUnsharedPoolPartitions"/>
<xsl:template match="connectionPool/@numberOfFreePoolPartitions"/>
<xsl:template match="connectionPool/@numberOfUnsharedPoolPartitions"/>
<xsl:template match="connectionPool/@freePoolDistributionTableSize"/>
<xsl:template match="connectionPool/@surgeThreshold"/>
<xsl:template match="connectionPool/@surgeCreationInterval"/>
<xsl:template match="connectionPool/@testConnection"/>
<xsl:template match="connectionPool/@testConnectionInterval"/>
<xsl:template match="connectionPool/@stuckTimerTime"/>
<xsl:template match="connectionPool/@stuckTime"/>
<xsl:template match="connectionPool/@stuckThreshold"/>

<xsl:template match="sessionPool/properties"/>
<xsl:template match="sessionPool/@numberOfSharedPoolPartitions"/>
<xsl:template match="sessionPool/@numberOfUnsharedPoolPartitions"/>
<xsl:template match="sessionPool/@numberOfFreePoolPartitions"/>
<xsl:template match="sessionPool/@numberOfUnsharedPoolPartitions"/>
<xsl:template match="sessionPool/@freePoolDistributionTableSize"/>
<xsl:template match="sessionPool/@surgeThreshold"/>
<xsl:template match="sessionPool/@surgeCreationInterval"/>
<xsl:template match="sessionPool/@testConnection"/>
<xsl:template match="sessionPool/@testConnectionInterval"/>
<xsl:template match="sessionPool/@stuckTimerTime"/>
<xsl:template match="sessionPool/@stuckTime"/>
<xsl:template match="sessionPool/@stuckThreshold"/>

<!-- Remove the providerType attribute from a number of resources*.xml files
     Defect: 232876 -->
<xsl:template match="factories/@providerType"/>

<!-- resources.env -->


<!-- resources.j2c -->

<!-- Remove any 1.5 J2CResourceAdapters. -->
<xsl:template match="resources.j2c:J2CResourceAdapter">
  <!-- We know it is a 1.0 RA if there is no deploymentDescriptor element, or there is
       a DD element but the specVersion=1.0 -->
  <!-- d573562 Don't remove builtin_rra. -->
  <xsl:if test="not(deploymentDescriptor) or deploymentDescriptor/@specVersion='1.0' or @xmi:id='builtin_rra'">
    <xsl:call-template name="copy"/>
  </xsl:if>
</xsl:template>

<!-- What's left is just the 1.0 RA. Get rid of the dd if it exists
     Defect: 222308 -->
<xsl:template match="resources.j2c:J2CResourceAdapter/deploymentDescriptor"/>

<!-- Again, CMPConnectionFactory extends J2CConnectionFactory -->

<!-- d573562 Correctly remove connectionDefinition reference. -->
<xsl:template match="@connectionDefinition[../@xmi:type='resources.jdbc:CMPConnectorFactory']"></xsl:template>
<xsl:template match="resources.j2c:J2CConnectionFactory/connectionDefinition"/>
<xsl:template match="resources.j2c:J2CConnectionFactory/customProperties"/>
<xsl:template match="resources.j2c:J2CConnectionFactory/@connectionDefinition"/>
<xsl:template match="resources.jdbc:CMPConnectionFactory/connectionDefinition"/>
<xsl:template match="resources.jdbc:CMPConnectionFactory/customProperties"/>
<xsl:template match="resources.jdbc:CMPConnectionFactory/@connectionDefinition"/>
<xsl:template match="connectionDefinition">
  <xsl:if test="not(../@xmi:type='resources.j2c:J2CConnectionFactory' or
                    ../@xmi:type='resources.jdbc:CMPConnectionFactory')">
    <xsl:call-template name="copy"/>
  </xsl:if>
</xsl:template>
<xsl:template match="customProperties">
  <xsl:if test="not(../@xmi:type='resources.j2c:J2CConnectionFactory' or
                    ../@xmi:type='resources.jdbc:CMPConnectionFactory')">
    <xsl:call-template name="copy"/>
  </xsl:if>
</xsl:template>
<xsl:template match="@connectionDefinition">
  <xsl:if test="not(../@xmi:type='resources.j2c:J2CConnectionFactory' or
                    ../@xmi:type='resources.jdbc:CMPConnectionFactory')">
    <xsl:call-template name="copy"/>
  </xsl:if>
</xsl:template>

<!-- Remove stuff from the J2C 1.0 RA; this is only matched for
     a 1.0 RA since the 1.5 RA is removed above. -->
<xsl:template match="resources.j2c:J2CResourceAdapter/threadPoolAlias"/>
<xsl:template match="resources.j2c:J2CResourceAdapter/connectionDefTemplateProps"/>
<xsl:template match="resources.j2c:J2CResourceAdapter/activationDefTemplateProps"/>
<xsl:template match="resources.j2c:J2CResourceAdapter/j2cAdminObjects"/>
<xsl:template match="resources.j2c:J2CResourceAdapter/adminObjectTemplateProps"/>
<xsl:template match="resources.j2c:J2CResourceAdapter/j2cActivationSpec"/>
<xsl:template match="resources.j2c:J2CResourceAdapter/@threadPoolAlias"/>

<!-- resources.jdbc -->

<!-- resources.jms -->

<xsl:template match="resources.jms:JMSProvider/supportsASF"/>
<xsl:template match="resources.jms:JMSProvider/@supportsASF"/>

<!-- resources.mail -->

<xsl:template match="resources.mail:MailProvider/factories/@strict">
  <xsl:if test="not(../@xmi:type='resources.mail:MailSession')">
    <xsl:call-template name="copy"/>
  </xsl:if>
</xsl:template>

<xsl:template match="resources.mail:MailProvider/factories/strict">
  <xsl:if test="not(../@xmi:type='resources.mail:MailSession')">
    <xsl:call-template name="copy"/>
  </xsl:if>
</xsl:template>

<!-- resources.url -->

<!-- resources-pme.xml -->

<!-- Remove the useAdminRoles attribute from the SchedulerProvider
     Deliverable record: LIDB2461.21
-->
<xsl:template match="scheduler:SchedulerProvider/factories/@useAdminRoles"/>

<!-- Change the following WCCM attributes to resourceProperties in a propertySet:
     - defTranClass
     - daemonTranClass
     - workReqQSize
     - workReqQFullAction
     Also, delete the following WCCM attributes completely:
     - workTimeout
     - isDistributable
     LI: 2915.11
-->
<xsl:template match="workmanager:WorkManagerProvider/factories">
  <!-- We match the 'factories' element and copy most of it; however do not copy
       certain attributes -->
  <xsl:copy>
    <xsl:for-each select="@*">
      <xsl:if test="not(local-name(.)='defTranClass' or local-name(.)='daemonTranClass' or
                        local-name(.)='workReqQSize' or local-name(.)='workReqQFullAction' or
                        local-name(.)='workTimeout' or local-name(.)='isDistributable')">
        <xsl:copy>
          <xsl:apply-templates/>
        </xsl:copy>
      </xsl:if>
    </xsl:for-each>
    <!-- If one of the attributes we are trying to convert exists, create a 'propertySet' -->
    <xsl:if test="@defTranClass or @daemonTranClass or @workReqQSize or @workReqQFullAction">
      <xsl:text>&#xa;      </xsl:text>
      <xsl:element name="propertySet">
        <xsl:attribute name="xmi:id">
          <xsl:text>J2EEResourcePropertySet_</xsl:text>
          <xsl:number value="position()"/>
        </xsl:attribute>
        <!-- Loop through all the attributes and create properties for each one that exists -->
        <xsl:for-each select="@*">
          <xsl:choose>
            <xsl:when test="local-name(.)='defTranClass'">
              <xsl:call-template name="createProperty">
                <xsl:with-param name="name">com.ibm.ws.asynchbeans.zos.wlm.default.transaction.class</xsl:with-param>
                <xsl:with-param name="value"><xsl:value-of select="."/></xsl:with-param>
              </xsl:call-template>
            </xsl:when>
            <xsl:when test="local-name(.)='daemonTranClass'">
              <xsl:call-template name="createProperty">
                <xsl:with-param name="name">com.ibm.ws.asynchbeans.zos.wlm.daemon.transaction.class</xsl:with-param>
                <xsl:with-param name="value"><xsl:value-of select="."/></xsl:with-param>
              </xsl:call-template>
            </xsl:when>
            <xsl:when test="local-name(.)='workReqQSize'">
              <xsl:call-template name="createProperty">
                <xsl:with-param name="name">WORKREQUEST_QUEUE_SIZE</xsl:with-param>
                <xsl:with-param name="value"><xsl:value-of select="."/></xsl:with-param>
              </xsl:call-template>
            </xsl:when>
            <xsl:when test="local-name(.)='workReqQFullAction'">
              <xsl:call-template name="createProperty">
                <xsl:with-param name="name">WORKREQUEST_QUEUE_FULL_ACTION</xsl:with-param>
                <xsl:with-param name="value"><xsl:value-of select="."/></xsl:with-param>
              </xsl:call-template>
            </xsl:when>
          </xsl:choose>
        </xsl:for-each>
      </xsl:element>
    </xsl:if>
    <!-- Make sure we copy additional nodes, if they exist -->
    <xsl:apply-templates select="node()"/>
  </xsl:copy>
</xsl:template>

<!-- Create a 'resourceProperties' element containing the 'name' and 'value'
     params which are passed.
     LI: 2915.11
-->
<xsl:template name="createProperty">
  <xsl:param name="name"/>
  <xsl:param name="value"/>
  <xsl:text>&#xa;        </xsl:text>
  <xsl:element name="resourceProperties">
    <xsl:attribute name="xmi:id">
      <xsl:text>J2EEResourceProperty_</xsl:text>
      <xsl:number value="position()"/>
    </xsl:attribute>
    <xsl:attribute name="name"><xsl:value-of select="$name"/></xsl:attribute>
    <xsl:attribute name="value"><xsl:value-of select="$value"/></xsl:attribute>
  </xsl:element>
</xsl:template>

<!-- Delete the TimerManagerProvider element and everything it contains.
     LI: 2915.11
-->
<xsl:template match="workmanager:TimerManagerProvider"/>

<!-- JetStream changes; see DR for more information, as there are lots of
     changes contained here
     LI: 2117.64
-->
<xsl:template match="resources.jms:JMSProvider/factories/@msgSelection"/>
<xsl:template match="resources.jms:JMSProvider/factories/@publishAckInterval"/>
<xsl:template match="resources.jms:JMSProvider/factories/@sparseSubscriptions"/>
<xsl:template match="resources.jms:JMSProvider/factories/@statRefreshInterval"/>
<xsl:template match="resources.jms:JMSProvider/factories/@substore"/>
<xsl:template match="resources.jms:JMSProvider/factories/@multicast"/>
<xsl:template match="resources.jms:JMSProvider/factories/@directAuth"/>
<xsl:template match="resources.jms:JMSProvider/factories/@proxyHostName"/>
<xsl:template match="resources.jms:JMSProvider/factories/@proxyPort"/>
<xsl:template match="resources.jms:JMSProvider/factories/@failIfQuiesce"/>
<xsl:template match="resources.jms:JMSProvider/factories/@localAddress"/>
<xsl:template match="resources.jms:JMSProvider/factories/@pollingInterval"/>
<xsl:template match="resources.jms:JMSProvider/factories/@rescanInterval"/>
<xsl:template match="resources.jms:JMSProvider/factories/@sslCipherSuite"/>
<xsl:template match="resources.jms:JMSProvider/factories/@sslCRL"/>
<xsl:template match="resources.jms:JMSProvider/factories/@sslPeerName"/>
<xsl:template match="resources.jms:JMSProvider/factories/@tempQueuePrefix"/>
<xsl:template match="resources.jms:JMSProvider/factories/@useConnectionPooling"/>
<xsl:template match="resources.jms:JMSProvider/factories/@pubSubCleanup"/>
<xsl:template match="resources.jms:JMSProvider/factories/@pubSubCleanupInterval"/>
<xsl:template match="resources.jms:JMSProvider/factories/@multicast"/>

<xsl:template match="resources.jms:JMSProvider/factories">
  <xsl:if test="not(@xmi:type='resources.jms.mqseries:MQConnectionFactory' or
                    @transportType='DIRECTHTTP' or
                    (@xmi:type='resources.jms:GenericJMSConnectionFactory' and @type='UNIFIED'))">
    <xsl:call-template name="copy"/>
  </xsl:if>
</xsl:template>

<!-- LI: 4435.21 - Delete the singleton attribute on J2CResourceAdapter -->
<xsl:template match="resources.j2c:J2CResourceAdapter/@singleton"/>
<!-- LI: 4190-32.1 - Removes the custom property 'optimizeForGetUseClose' from DB2Universal Providers -->
<xsl:template match="resources.jdbc:JDBCProvider/factories/propertySet/resourceProperties[@name='optimizeForGetUseClose']"/>

<!-- LI: 4396.16 - Removal of isEnableHASupport and hACapability from J2CResourceAdapter -->
<xsl:template match="resources.j2c:J2CResourceAdapter/@isEnableHASupport"/>
<xsl:template match="resources.j2c:J2CResourceAdapter/@hACapability"/>

<!-- LI: 4245.13 - Remove SSL mail protocol providers -->
<xsl:template match="resources.mail:MailProvider/protocolProviders">
  <xsl:if test="not(@xmi:id='builtin_imaps' or
                    @xmi:id='builtin_pop3s' or
                    @xmi:id='builtin_smtps')">
    <xsl:call-template name="copy"/>
  </xsl:if>
</xsl:template>

<!-- LI: 4500-17.5 - Remove isolatedClassLoader attribute from all elements -->
<xsl:template match="*/@isolatedClassLoader"/>

<!-- LI: 3862-5 - Removes the custom property 'propagateClientIdentityUsingTrustedContext' from DB2Universal Providers -->
<xsl:template match="resources.jdbc:JDBCProvider/factories/propertySet/resourceProperties[@name='propagateClientIdentityUsingTrustedContext']"/>

<!-- 448785 -->
<xsl:template match="resources.jdbc:JDBCProvider/factories/propertySet/resourceProperties[@name='connRetriesDuringDBFailover']"/>
<xsl:template match="resources.jdbc:JDBCProvider/factories/propertySet/resourceProperties[@name='connRetryIntervalDuringDBFailover']"/>
<xsl:template match="resources.jdbc:JDBCProvider/factories/propertySet/resourceProperties[@name='dbFailOverEnabled']"/>
<xsl:template match="resources.jdbc:JDBCProvider/factories/propertySet/resourceProperties[@name='jmsOnePhaseOptimization']"/>
<xsl:template match="resources.jdbc:JDBCProvider/factories/propertySet/resourceProperties[@name='reauthentication']"/>

<!-- 509503 -->
<xsl:template match="resources.jdbc:JDBCProvider/factories/propertySet/resourceProperties[@name='beginTranForResultSetScrollingAPIs']"/>
<xsl:template match="resources.jdbc:JDBCProvider/factories/propertySet/resourceProperties[@name='beginTranForVendorAPIs']"/>
<!-- 510150.1 -->
<xsl:template match="resources.jdbc:JDBCProvider/factories/propertySet/resourceProperties[@name='connectionSharing']"/>

<!-- LIDB3293-24 start
    Remove the new custom properties for LIDB3293, LIDB3483, LIDB4187 -->
<!-- LIDB3293 new properties -->
<xsl:template match="resources.jdbc:JDBCProvider/factories/propertySet/resourceProperties[@name='errorDetectionModel']"/>
<xsl:template match="resources.jdbc:JDBCProvider/factories/propertySet/resourceProperties[@name='withholdPoolabilityHintFromJDBCDriver']"/>
<xsl:template match="resources.jdbc:JDBCProvider/factories/propertySet/resourceProperties[@name='validateNewConnectionTimeout']"/>

<!-- LIDB3493 new properties -->
<xsl:template match="resources.jdbc:JDBCProvider/factories/propertySet/resourceProperties[@name='clientRerouteServerListJNDIName']"/>
<xsl:template match="resources.jdbc:JDBCProvider/factories/propertySet/resourceProperties[@name='unbindClientRerouteListFromJndi']"/>
<!-- 503220 CRAltServerName and CRAltPortNum are not removed.  They can also be used as actual DB2 DS props. -->

<!-- LIDB4187 new properties -->
<xsl:template match="resources.jdbc:JDBCProvider/factories/propertySet/resourceProperties[@name='nonTransactionalDataSource']"/>
<!-- LIDB3293-24 end -->

<!-- 503220 review of RRA properties not in WAS51 -->
<xsl:template match="resources.jdbc:JDBCProvider/factories/propertySet/resourceProperties[@name='freeResourcesOnClose']"/>
<xsl:template match="resources.jdbc:JDBCProvider/factories/propertySet/resourceProperties[@name='supplementalTrace']"/>
<xsl:template match="resources.jdbc:JDBCProvider/factories/propertySet/resourceProperties[@name='isolationLevelSwitchingSupport']"/>
<xsl:template match="resources.jdbc:JDBCProvider/factories/propertySet/resourceProperties[@name='validateAfterConnectionError']"/>
<xsl:template match="resources.jdbc:JDBCProvider/factories/propertySet/resourceProperties[@name='resetConnectionByBackendDatabase']"/>
<xsl:template match="resources.jdbc:JDBCProvider/factories/propertySet/resourceProperties[@name='disableWASConnectionPooling']"/>
<xsl:template match="resources.jdbc:JDBCProvider/factories/propertySet/resourceProperties[@name='connectionCachingEnabled']"/>
<xsl:template match="resources.jdbc:JDBCProvider/factories/propertySet/resourceProperties[@name='connectionCacheName']"/>
<xsl:template match="resources.jdbc:JDBCProvider/factories/propertySet/resourceProperties[@name='removeExistingOracleConnectionPoolIfExists']"/>
<xsl:template match="resources.jdbc:JDBCProvider/factories/propertySet/resourceProperties[@name='validateNewConnection']"/>
<xsl:template match="resources.jdbc:JDBCProvider/factories/propertySet/resourceProperties[@name='validateNewConnectionRetryCount']"/>
<xsl:template match="resources.jdbc:JDBCProvider/factories/propertySet/resourceProperties[@name='validateNewConnectionRetryInterval']"/>
<xsl:template match="resources.jdbc:JDBCProvider/factories/propertySet/resourceProperties[@name='commitOrRollbackOnCleanup']"/>
<xsl:template match="resources.jdbc:JDBCProvider/factories/propertySet/resourceProperties[@name='optimizeDB2ForGetUseClose']"/>
<xsl:template match="resources.jdbc:JDBCProvider/factories/propertySet/resourceProperties[@name='useTrustedContextWithAuthentication']"/>
<xsl:template match="resources.jdbc:JDBCProvider/factories/propertySet/resourceProperties[@name='displaySQLWarningsOnConnectionCleanup']"/>
<xsl:template match="resources.jdbc:JDBCProvider/factories/propertySet/resourceProperties[@name='clearSQLWarningsOnConnectionCleanup']"/>
<xsl:template match="resources.jdbc:JDBCProvider/factories/propertySet/resourceProperties[@name='nondeferredreaper']"/>
<xsl:template match="resources.jdbc:JDBCProvider/factories/propertySet/resourceProperties[@name='userDefinedErrorMap']"/>

<!-- 503220 Remove DB2 JDBC 4.0 driver -->
<xsl:template match="resources.jdbc:JDBCProvider[starts-with(@providerType, 'DB2 Using IBM JCC Driver')]"/>
<xsl:template match="resources.j2c:J2CResourceAdapter/factories[@xmi:type='resources.jdbc:CMPConnectorFactory']">
  <xsl:variable name="idToMatch" select="@cmpDatasource"/>
  <xsl:choose>
    <!-- Remove this CMP connection factory when the cmpDatasource attribute matches a removed DataSource -->
    <xsl:when test="//resources.jdbc:JDBCProvider/factories[@xmi:id=$idToMatch and starts-with(@providerType, 'DB2 Using IBM JCC Driver')]"/>
    <xsl:otherwise>
      <xsl:call-template name="copy"/>
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>

<!-- LIDB4602-30 start -->
<!-- This will remove a JDBCProvider's (NOT a factory's) propertySet which contains a MIGRATED_PROVIDER property -->
<xsl:template match="resources.jdbc:JDBCProvider/propertySet[resourceProperties/@name='MIGRATED_PROVIDER']"/>
<!-- Something to note: the practice of calling <apply:templates select="."/> will run the current
     element/attribute through any templates that match, so if it matches a template that is defined
     to remove or change the element, then it will apply that template.  If it does not match any
     template defined, then it will match the copy template which will recursively/deep copy the
     element/attribute  (and once again, on each sub-element/attribute, apply any templates) -->
<xsl:template match="resources.jdbc:JDBCProvider">
<!-- Only copy the JDBCProvider if: it is not specified as using isolatedClassLoader, or
     it is a migrated provider (custom property MIGRATED_PROVIDER='true') -->
<!-- 490078 on following line, change from @isolatedClassLoader='false' to not(@isolatedClassLoader='true'),
     this is because (@isolatedClassLoader='true') will return false if the isolatedClassLoader attribute either is false,
     or does not exist on the jdbc provider. -->
 <xsl:if test="not(@isolatedClassLoader='true') or boolean(propertySet/resourceProperties[@name='MIGRATED_PROVIDER' and @value='true'])">
  <xsl:choose>
    <xsl:when test="factories/propertySet/resourceProperties/@name='MIGROLD_datasourceHelperClassname'">
      <!-- If there is even one property with name='MIGROLD_datasourceHelperClassname', then this is a migrated JDBCProvider -->
      <xsl:element name="resources.jdbc:JDBCProvider">
        <!-- This will copy all JDBCProvider attributes, while applying any templates. -->
        <xsl:apply-templates select="@*"/>
        <!-- The following call-template sections will call the templates below, this will act like a function call -->
        <!-- 5.x version note:  Do not call the mapMigratedProvider template (which does not exist) since providerType attribute
          does not exist on 5.x -->
        <xsl:call-template name="mapMigratedImplementation">
          <xsl:with-param name="providerType"><xsl:value-of select="@providerType"/></xsl:with-param>
        </xsl:call-template>
        <xsl:call-template name="mapMigratedClasspaths">
          <xsl:with-param name="providerType"><xsl:value-of select="@providerType"/></xsl:with-param>
        </xsl:call-template>
        <xsl:for-each select="*">
          <xsl:choose>
            <xsl:when test="name()='factories'">
              <!-- Start copying the factories (data sources) over -->
              <xsl:element name="factories">
                <!-- This statement will copy all of the attributes of the factories (data source) -->
                <xsl:apply-templates select="@*"/>
                <!-- 5.x comment: mapMigratedProvider not called since providerType does not exist in 5.x -->
                <xsl:attribute name="datasourceHelperClassname">
                  <!-- Find the resourceProperties element with the name 'MIGROLD_datasourceHelperClassname'
                    and use the value for the new datasourceHelperClassname of the factory. -->
                  <xsl:value-of select="propertySet/resourceProperties[@name='MIGROLD_datasourceHelperClassname']/@value"/>
                </xsl:attribute>
                <!-- The following loop will copy all elements of the factory (datasource) that are not propertySets -->
                <xsl:for-each select="*">
                  <xsl:variable name="type" select="name()"/>
                  <xsl:if test="not($type='propertySet')">
                    <xsl:apply-templates select="."/>
                  </xsl:if>
                </xsl:for-each>
                <!-- Now copy all the properties of each propertySet, only copying the resourceProperties that
                  start with MIGROLD_, and when copying, remove the MIGROLD_ tag from the name -->
                <xsl:for-each select="propertySet">
                  <xsl:element name="propertySet">
                    <xsl:attribute name="xmi:id"><xsl:value-of select="@xmi:id"/></xsl:attribute>
                    <!-- For resourceProperties, we do not need to worry about applying the other templates, since we already
                      will be stripping out any of the new properties from the higher release and restoring the properties
                      from the previous release, so none of the properties to remove will exist -->
                    <xsl:for-each select="resourceProperties">
                      <xsl:if test="starts-with(@name,'MIGROLD_') and not(@name='MIGROLD_datasourceHelperClassname')">
                        <xsl:element name="resourceProperties">
                          <xsl:for-each select="@*">
                            <xsl:apply-templates select="."/>
                            <!-- <xsl:attribute name="{name()}"><xsl:value-of select="."/></xsl:attribute> -->
                          </xsl:for-each>
                          <!-- Remove the MIGROLD_ from the name -->
                          <xsl:attribute name="name"><xsl:value-of select="substring-after(@name,'MIGROLD_')"/></xsl:attribute>
                        </xsl:element>
                      </xsl:if>
                    </xsl:for-each>
                  </xsl:element>
                </xsl:for-each>
              </xsl:element>
            </xsl:when>
            <!-- The Embedded DataDirect JDBC Driver has its own classpath -->
            <xsl:when test="not(name()='classpath')">
              <xsl:call-template name="copy"/>
            </xsl:when>
          </xsl:choose>
        </xsl:for-each>
      </xsl:element>
    </xsl:when>
    <!-- This when clause is for xforming non-migrated providers created in a mixed-cell evironment. -->
    <!-- 492056 Added iSeries Native -->
    <!-- 494973.1 Added ConnectJDBC -->
    <!-- 497699 Fixed Oracle providerType test -->
    <xsl:when test="@providerType='Oracle JDBC Driver'
                    or @providerType='Oracle JDBC Driver (XA)'
                    or @providerType='DB2 UDB for iSeries (Native)'
                    or @providerType='DB2 UDB for iSeries (Native XA)'
                    or @providerType='DataDirect ConnectJDBC type 4 driver for MS SQL Server'
                    or @providerType='DataDirect ConnectJDBC type 4 driver for MS SQL Server (XA)'
                    ">
      <xsl:copy>
        <xsl:for-each select="node() | @*">
          <xsl:choose>
            <xsl:when test="name()='classpath'">
              <xsl:call-template name="mapClasspaths">
                <xsl:with-param name="providerType">
                  <xsl:value-of select="../@providerType" />
                </xsl:with-param>
              </xsl:call-template>
            </xsl:when>
            <xsl:otherwise>
              <xsl:apply-templates select="."/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:for-each>
      </xsl:copy>
    </xsl:when>
    <xsl:otherwise>
      <xsl:call-template name="copy"/>
    </xsl:otherwise>
  </xsl:choose>
 </xsl:if>

</xsl:template>

<!-- following functions are added so that if other drivers are migrated/mapped to something else in the future,
     then the tools will already be here to provide the mapping back -->
<xsl:template name="mapMigratedImplementation">
  <xsl:param name="providerType"/>
  <xsl:choose>
    <xsl:when test="$providerType='DataDirect ConnectJDBC type 4 driver for MS SQL Server' or $providerType='Microsoft SQL Server JDBC Driver'
       or $providerType='DataDirect ConnectJDBC type 4 driver for MS SQL Server (XA)' or $providerType='Microsoft SQL Server JDBC Driver (XA)'">
      <xsl:attribute name="implementationClassName"><xsl:text>com.ibm.websphere.jdbcx.sqlserver.SQLServerDataSource</xsl:text></xsl:attribute>
    </xsl:when>
  </xsl:choose>
</xsl:template>

<xsl:template name="mapMigratedClasspaths">
  <xsl:param name="providerType"/>
  <xsl:choose>
    <xsl:when test="$providerType='DataDirect ConnectJDBC type 4 driver for MS SQL Server' or $providerType='Microsoft SQL Server JDBC Driver'
       or $providerType='DataDirect ConnectJDBC type 4 driver for MS SQL Server (XA)' or $providerType='Microsoft SQL Server JDBC Driver (XA)'">
      <xsl:element name="classpath"><xsl:text>${WAS_LIBS_DIR}/sqlserver.jar</xsl:text></xsl:element>
      <xsl:element name="classpath"><xsl:text>${WAS_LIBS_DIR}/base.jar</xsl:text></xsl:element>
      <xsl:element name="classpath"><xsl:text>${WAS_LIBS_DIR}/util.jar</xsl:text></xsl:element>
      <xsl:element name="classpath"><xsl:text>${WAS_LIBS_DIR}/spy.jar</xsl:text></xsl:element>
    </xsl:when>
    <xsl:when test="$providerType='Oracle JDBC Driver' or $providerType='Oracle JDBC Driver (XA)'">
      <!-- Copy the classpath element and replace ojdbc6.jar with ojdbc14.jar, keeping any path prefix -->
      <xsl:copy>
        <xsl:choose>
          <!-- 497699 -->
          <xsl:when test="contains(., 'ojdbc6.jar' )">
            <xsl:value-of select="substring-before(., 'ojdbc6.jar')"/><xsl:text>ojdbc14.jar</xsl:text>
          </xsl:when>
          <xsl:when test="contains(., 'ojdbc6_g.jar' )">
            <xsl:value-of select="substring-before(., 'ojdbc6_g.jar')"/><xsl:text>ojdbc14_g.jar</xsl:text>
          </xsl:when>
          <!-- other path elements are copied as-is -->
          <xsl:otherwise>
            <xsl:value-of select="."/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:copy>
    </xsl:when>
    <!-- 492056 Change ${OS400_NATIVE_JDBC40_DRIVER_PATH}/db2_classes16.jar to ${OS400_NATIVE_JDBC_DRIVER_PATH}/db2_classes.jar -->
    <xsl:when test="$providerType='DB2 UDB for iSeries (Native)' or $providerType='DB2 UDB for iSeries (Native XA)'">
      <xsl:element name="classpath"><xsl:text>${OS400_NATIVE_JDBC_DRIVER_PATH}/db2_classes.jar</xsl:text></xsl:element>
    </xsl:when>
  </xsl:choose>
</xsl:template>
<!-- End LIDB4602-30 -->

<!-- These are classpath transforms for NON-migrated providers. -->
<xsl:template name="mapClasspaths">
  <xsl:param name="providerType"/>
  <xsl:choose>
    <xsl:when test="$providerType='Oracle JDBC Driver' or $providerType='Oracle JDBC Driver (XA)'">
      <!-- Copy the classpath element and replace ojdbc6.jar with ojdbc14.jar, keeping any path prefix -->
      <xsl:copy>
        <xsl:choose>
          <!-- 497699 -->
          <xsl:when test="contains(., 'ojdbc6.jar' )">
            <xsl:value-of select="substring-before(., 'ojdbc6.jar')"/><xsl:text>ojdbc14.jar</xsl:text>
          </xsl:when>
          <xsl:when test="contains(., 'ojdbc6_g.jar' )">
            <xsl:value-of select="substring-before(., 'ojdbc6_g.jar')"/><xsl:text>ojdbc14_g.jar</xsl:text>
          </xsl:when>
          <!-- other path elements are copied as-is -->
          <xsl:otherwise>
            <xsl:value-of select="."/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:copy>
    </xsl:when>
    <!-- 492056 Change ${OS400_NATIVE_JDBC40_DRIVER_PATH}/db2_classes16.jar to ${OS400_NATIVE_JDBC_DRIVER_PATH}/db2_classes.jar -->
    <xsl:when test="$providerType='DB2 UDB for iSeries (Native)' or $providerType='DB2 UDB for iSeries (Native XA)'">
      <xsl:element name="classpath"><xsl:text>${OS400_NATIVE_JDBC_DRIVER_PATH}/db2_classes.jar</xsl:text></xsl:element>
    </xsl:when>
    <!-- 494973.1 Added ConnectJDBC -->
    <xsl:when test="$providerType='DataDirect ConnectJDBC type 4 driver for MS SQL Server'
                    or $providerType='DataDirect ConnectJDBC type 4 driver for MS SQL Server (XA)'
                    ">
      <xsl:element name="classpath"><xsl:text>${CONNECTJDBC_JDBC_DRIVER_PATH}/sqlserver.jar</xsl:text></xsl:element>
      <xsl:element name="classpath"><xsl:text>${CONNECTJDBC_JDBC_DRIVER_PATH}/base.jar</xsl:text></xsl:element>
      <xsl:element name="classpath"><xsl:text>${CONNECTJDBC_JDBC_DRIVER_PATH}/util.jar</xsl:text></xsl:element>
      <xsl:element name="classpath"><xsl:text>${CONNECTJDBC_JDBC_DRIVER_PATH}/../spy/spy.jar</xsl:text></xsl:element>
    </xsl:when>
  </xsl:choose>
</xsl:template>

<!-- feature 477886.3 - Remove mailStorePort and mailTransportPort attributes from MailSession -->
<xsl:template match="resources.mail:MailProvider/factories/@mailStorePort">
  <xsl:if test="not(../@xmi:type='resources.mail:MailSession')">
    <xsl:call-template name="copy"/>
  </xsl:if>
</xsl:template>

<xsl:template match="resources.mail:MailProvider/factories/@mailTransportPort">
  <xsl:if test="not(../@xmi:type='resources.mail:MailSession')">
    <xsl:call-template name="copy"/>
  </xsl:if>
</xsl:template>

</xsl:stylesheet>

