<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:xmi="http://www.omg.org/XMI"
  xmlns:resources="http://www.ibm.com/websphere/appserver/schemas/5.0/resources.xmi"
  xmlns:resources.env="http://www.ibm.com/websphere/appserver/schemas/5.0/resources.env.xmi"
  xmlns:resources.j2c="http://www.ibm.com/websphere/appserver/schemas/5.0/resources.j2c.xmi"
  xmlns:resources.jdbc="http://www.ibm.com/websphere/appserver/schemas/5.0/resources.jdbc.xmi"
  xmlns:resources.jms="http://www.ibm.com/websphere/appserver/schemas/5.0/resources.jms.xmi"
  xmlns:resources.mail="http://www.ibm.com/websphere/appserver/schemas/5.0/resources.mail.xmi"
  xmlns:resources.url="http://www.ibm.com/websphere/appserver/schemas/5.0/resources.url.xmi"
  xmlns:scheduler="http://www.ibm.com/websphere/appserver/schemas/5.0/scheduler.xmi"
  xmlns:workmanager="http://www.ibm.com/websphere/appserver/schemas/5.0/workmanager.xmi">

  <xsl:import href="copy.xsl"/>

  <!-- Remove "WebSphere MQ Resource Adapter - builtin" RA -->
  <xsl:template match="resources.j2c:J2CResourceAdapter">
    <xsl:if test="not(@description='WAS 7.0 Built In WebSphere MQ Resource Adapter') and not(@description='WAS 7.0 Built In WebSphere MQ Resource Adapter - Converted') and not(@description='WAS 7.0.0.1 Built In WebSphere MQ Resource Adapter')">
      <xsl:call-template name="copy"/>
    </xsl:if>
  </xsl:template>

  <!-- Remove providerEndpoints from activationSpecs -->
  <xsl:template match="resources.j2c:J2CResourceAdapter/activationSpecTemplateProps/resourceProperties[@name='providerEndpoints']">
    <xsl:if test="not(../../@name='SIB JMS Resource Adapter')">
      <xsl:call-template name="copy"/>
    </xsl:if>
  </xsl:template>
  <xsl:template match="resources.j2c:J2CResourceAdapter/j2cActivationSpec/resourceProperties[@name='providerEndpoints']">
    <xsl:if test="not(../../@name='SIB JMS Resource Adapter')">
      <xsl:call-template name="copy"/>
    </xsl:if>
  </xsl:template>

  <!-- Remove alwaysActivateAllMDBs from activationSpecs -->
  <xsl:template match="resources.j2c:J2CResourceAdapter/activationSpecTemplateProps/resourceProperties[@name='alwaysActivateAllMDBs']">
    <xsl:if test="not(../../@name='SIB JMS Resource Adapter')">
      <xsl:call-template name="copy"/>
    </xsl:if>
  </xsl:template>
  <xsl:template match="resources.j2c:J2CResourceAdapter/j2cActivationSpec/resourceProperties[@name='alwaysActivateAllMDBs']">
    <xsl:if test="not(../../@name='SIB JMS Resource Adapter')">
      <xsl:call-template name="copy"/>
    </xsl:if>
  </xsl:template>

  <!-- Remove retryInterval from activationSpecs -->
  <xsl:template match="resources.j2c:J2CResourceAdapter/activationSpecTemplateProps/resourceProperties[@name='retryInterval']">
    <xsl:if test="not(../../@name='SIB JMS Resource Adapter')">
      <xsl:call-template name="copy"/>
    </xsl:if>
  </xsl:template>
  <xsl:template match="resources.j2c:J2CResourceAdapter/j2cActivationSpec/resourceProperties[@name='retryInterval']">
    <xsl:if test="not(../../@name='SIB JMS Resource Adapter')">
      <xsl:call-template name="copy"/>
    </xsl:if>
  </xsl:template>

  <!-- Remove ForwarderDoesNotModifyPayloadAfterSet from activationSpecs -->
  <xsl:template match="resources.j2c:J2CResourceAdapter/activationSpecTemplateProps/resourceProperties[@name='ForwarderDoesNotModifyPayloadAfterSet']">
    <xsl:if test="not(../../@name='SIB JMS Resource Adapter')">
      <xsl:call-template name="copy"/>
    </xsl:if>
  </xsl:template>
  <xsl:template match="resources.j2c:J2CResourceAdapter/j2cActivationSpec/resourceProperties[@name='ForwarderDoesNotModifyPayloadAfterSet']">
    <xsl:if test="not(../../@name='SIB JMS Resource Adapter')">
      <xsl:call-template name="copy"/>
    </xsl:if>
  </xsl:template>

  <!-- Remove ConsumerDoesNotModifyPayloadAfterGet from activationSpecs -->
  <xsl:template match="resources.j2c:J2CResourceAdapter/activationSpecTemplateProps/resourceProperties[@name='ConsumerDoesNotModifyPayloadAfterGet']">
    <xsl:if test="not(../../@name='SIB JMS Resource Adapter')">
      <xsl:call-template name="copy"/>
    </xsl:if>
  </xsl:template>
  <xsl:template match="resources.j2c:J2CResourceAdapter/j2cActivationSpec/resourceProperties[@name='ConsumerDoesNotModifyPayloadAfterGet']">
    <xsl:if test="not(../../@name='SIB JMS Resource Adapter')">
      <xsl:call-template name="copy"/>
    </xsl:if>
  </xsl:template>

  <!-- Remove ConsumerDoesNotModifyPayloadAfterGet from factories -->
  <xsl:template match="resources.j2c:J2CResourceAdapter/factories/propertySet/resourceProperties[@name='ConsumerDoesNotModifyPayloadAfterGet']">
    <xsl:if test="not(../../../@name='SIB JMS Resource Adapter')">
      <xsl:call-template name="copy"/>
    </xsl:if>
  </xsl:template>
  <xsl:template match="resources.j2c:J2CResourceAdapter/deploymentDescriptor/resourceAdapter/outboundResourceAdapter/connectionDefinitions/configProperties[@name='ConsumerDoesNotModifyPayloadAfterGet']">
    <xsl:if test="not(../../../../../@name='SIB JMS Resource Adapter')">
      <xsl:call-template name="copy"/>
    </xsl:if>
  </xsl:template>
  <xsl:template match="resources.j2c:J2CResourceAdapter/connectionDefTemplateProps/resourceProperties[@name='ConsumerDoesNotModifyPayloadAfterGet']">
    <xsl:if test="not(../../@name='SIB JMS Resource Adapter')">
      <xsl:call-template name="copy"/>
    </xsl:if>
  </xsl:template>

  <!-- Remove ProducerDoesNotModifyPayloadAfterSet from factories -->
  <xsl:template match="resources.j2c:J2CResourceAdapter/factories/propertySet/resourceProperties[@name='ProducerDoesNotModifyPayloadAfterSet']">
    <xsl:if test="not(../../../@name='SIB JMS Resource Adapter')">
      <xsl:call-template name="copy"/>
    </xsl:if>
  </xsl:template>
  <xsl:template match="resources.j2c:J2CResourceAdapter/deploymentDescriptor/resourceAdapter/outboundResourceAdapter/connectionDefinitions/configProperties[@name='ProducerDoesNotModifyPayloadAfterSet']">
    <xsl:if test="not(../../../../../@name='SIB JMS Resource Adapter')">
      <xsl:call-template name="copy"/>
    </xsl:if>
  </xsl:template>
  <xsl:template match="resources.j2c:J2CResourceAdapter/connectionDefTemplateProps/resourceProperties[@name='ProducerDoesNotModifyPayloadAfterSet']">
    <xsl:if test="not(../../@name='SIB JMS Resource Adapter')">
      <xsl:call-template name="copy"/>
    </xsl:if>
  </xsl:template>

  <!-- Remove new v7 MQ JMS messaging provider attributes -->
  <xsl:template match="resources.jms:JMSProvider/factories/@compressHeaders">
    <xsl:if test="not(../../@name='WebSphere MQ JMS Provider')">
      <xsl:call-template name="copy"/>
    </xsl:if>
  </xsl:template>
  <xsl:template match="resources.jms:JMSProvider/factories/@compressPayload">
    <xsl:if test="not(../../@name='WebSphere MQ JMS Provider')">
      <xsl:call-template name="copy"/>
    </xsl:if>
  </xsl:template>
  <xsl:template match="resources.jms:JMSProvider/factories/@providerVersion">
    <xsl:if test="not(../../@name='WebSphere MQ JMS Provider')">
      <xsl:call-template name="copy"/>
    </xsl:if>
  </xsl:template>
  <xsl:template match="resources.jms:JMSProvider/factories/@wildcardFormat">
    <xsl:if test="not(../../@name='WebSphere MQ JMS Provider')">
      <xsl:call-template name="copy"/>
    </xsl:if>
  </xsl:template>
  <xsl:template match="resources.jms:JMSProvider/factories/@sslType">
    <xsl:if test="not(../../@name='WebSphere MQ JMS Provider')">
      <xsl:call-template name="copy"/>
    </xsl:if>
  </xsl:template>
  <xsl:template match="resources.jms:JMSProvider/factories/@sslConfiguration">
    <xsl:if test="not(../../@name='WebSphere MQ JMS Provider')">
      <xsl:call-template name="copy"/>
    </xsl:if>
  </xsl:template>
  <xsl:template match="resources.jms:JMSProvider/factories/@tempTopicPrefix">
    <xsl:if test="not(../../@name='WebSphere MQ JMS Provider')">
      <xsl:call-template name="copy"/>
    </xsl:if>
  </xsl:template>
  <xsl:template match="resources.jms:JMSProvider/factories/@replyWithRFH2">
    <xsl:if test="not(../../@name='WebSphere MQ JMS Provider')">
      <xsl:call-template name="copy"/>
    </xsl:if>
  </xsl:template>
  <xsl:template match="resources.jms:JMSProvider/factories/@maxBatchSize">
    <xsl:if test="not(../../@name='WebSphere MQ JMS Provider')">
      <xsl:call-template name="copy"/>
    </xsl:if>
  </xsl:template>
  <xsl:template match="resources.jms:JMSProvider/factories/@secExit">
    <xsl:if test="not(../../@name='WebSphere MQ JMS Provider')">
      <xsl:call-template name="copy"/>
    </xsl:if>
  </xsl:template>
  <xsl:template match="resources.jms:JMSProvider/factories/@secExitInitData">
    <xsl:if test="not(../../@name='WebSphere MQ JMS Provider')">
      <xsl:call-template name="copy"/>
    </xsl:if>
  </xsl:template>
  <xsl:template match="resources.jms:JMSProvider/factories/@sendExit">
    <xsl:if test="not(../../@name='WebSphere MQ JMS Provider')">
      <xsl:call-template name="copy"/>
    </xsl:if>
  </xsl:template>
  <xsl:template match="resources.jms:JMSProvider/factories/@sendExitInitData">
    <xsl:if test="not(../../@name='WebSphere MQ JMS Provider')">
      <xsl:call-template name="copy"/>
    </xsl:if>
  </xsl:template>
  <xsl:template match="resources.jms:JMSProvider/factories/@rcvExit">
    <xsl:if test="not(../../@name='WebSphere MQ JMS Provider')">
      <xsl:call-template name="copy"/>
    </xsl:if>
  </xsl:template>
  <xsl:template match="resources.jms:JMSProvider/factories/@rcvExitInitData">
    <xsl:if test="not(../../@name='WebSphere MQ JMS Provider')">
      <xsl:call-template name="copy"/>
    </xsl:if>
  </xsl:template>
  <xsl:template match="resources.jms:JMSProvider/factories/@sslResetCount">
    <xsl:if test="not(../../@name='WebSphere MQ JMS Provider')">
      <xsl:call-template name="copy"/>
    </xsl:if>
  </xsl:template>
  <xsl:template match="resources.jms:JMSProvider/factories/@brokerPubQueue">
    <xsl:if test="not(../../@name='WebSphere MQ JMS Provider') or not(../@xmi:type = 'resources.jms.mqseries:MQTopic')">
      <xsl:call-template name="copy"/>
    </xsl:if>
  </xsl:template>
  <xsl:template match="resources.jms:JMSProvider/factories/@brokerPubQmgr">
    <xsl:if test="not(../../@name='WebSphere MQ JMS Provider') or not(../@xmi:type = 'resources.jms.mqseries:MQTopic')">
      <xsl:call-template name="copy"/>
    </xsl:if>
  </xsl:template>
  <xsl:template match="resources.jms:JMSProvider/factories/@brokerVersion">
    <xsl:if test="not(../../@name='WebSphere MQ JMS Provider') or not(../@xmi:type = 'resources.jms.mqseries:MQTopic')">
      <xsl:call-template name="copy"/>
    </xsl:if>
  </xsl:template>
  <xsl:template match="resources.jms:JMSProvider/factories/@wmqServerName">
    <xsl:if test="not(../../@name='WebSphere MQ JMS Provider')">
      <xsl:call-template name="copy"/>
    </xsl:if>
  </xsl:template>
  <xsl:template match="resources.jms:JMSProvider/factories/@wmqServerEndpoint">
    <xsl:if test="not(../../@name='WebSphere MQ JMS Provider')">
      <xsl:call-template name="copy"/>
    </xsl:if>
  </xsl:template>
  <xsl:template match="resources.jms:JMSProvider/factories/@wmqServerSvrconnChannel">
    <xsl:if test="not(../../@name='WebSphere MQ JMS Provider')">
      <xsl:call-template name="copy"/>
    </xsl:if>
  </xsl:template>
  <xsl:template match="resources.jms:JMSProvider/factories/@ccdtUrl">
    <xsl:if test="not(../../@name='WebSphere MQ JMS Provider')">
      <xsl:call-template name="copy"/>
    </xsl:if>
  </xsl:template>
  <xsl:template match="resources.jms:JMSProvider/factories/@qmgrType">
    <xsl:if test="not(../../@name='WebSphere MQ JMS Provider')">
      <xsl:call-template name="copy"/>
    </xsl:if>
  </xsl:template>
  <xsl:template match="resources.jms:JMSProvider/factories/@sendAsync">
    <xsl:if test="not(../../@name='WebSphere MQ JMS Provider')">
      <xsl:call-template name="copy"/>
    </xsl:if>
  </xsl:template>
  <xsl:template match="resources.jms:JMSProvider/factories/@readAhead">
    <xsl:if test="not(../../@name='WebSphere MQ JMS Provider')">
      <xsl:call-template name="copy"/>
    </xsl:if>
  </xsl:template>
  <xsl:template match="resources.jms:JMSProvider/factories/@readAheadClose">
    <xsl:if test="not(../../@name='WebSphere MQ JMS Provider')">
      <xsl:call-template name="copy"/>
    </xsl:if>
  </xsl:template>
  <xsl:template match="resources.jms:JMSProvider/factories/@transportType[.='BINDINGS_THEN_CLIENT']">
    <xsl:attribute name="transportType">CLIENT</xsl:attribute>
  </xsl:template>


  <!-- Remove v7 JMS Queue properties -->
  <xsl:template match="resources.j2c:J2CResourceAdapter/j2cAdminObjects/properties[@name='scopeToLocalQP']">
    <xsl:if test="not(../../@name='SIB JMS Resource Adapter')">
      <xsl:call-template name="copy"/>
    </xsl:if>
  </xsl:template>
  <xsl:template match="resources.j2c:J2CResourceAdapter/j2cAdminObjects/properties[@name='producerBind']">
    <xsl:if test="not(../../@name='SIB JMS Resource Adapter')">
      <xsl:call-template name="copy"/>
    </xsl:if>
  </xsl:template>
  <xsl:template match="resources.j2c:J2CResourceAdapter/j2cAdminObjects/properties[@name='producerPreferLocal']">
    <xsl:if test="not(../../@name='SIB JMS Resource Adapter')">
      <xsl:call-template name="copy"/>
    </xsl:if>
  </xsl:template>
  <xsl:template match="resources.j2c:J2CResourceAdapter/j2cAdminObjects/properties[@name='gatherMessages']">
    <xsl:if test="not(../../@name='SIB JMS Resource Adapter')">
      <xsl:call-template name="copy"/>
    </xsl:if>
  </xsl:template>

</xsl:stylesheet>

