#!/bin/sh

# @start_restricted_prolog@
# Version: @(#) 1.6 SIB/ws/code/sib.webservices.wsgw/src/bin/unix/migratewsgw.sh, SIB.webservices.wsgw, WAS70.SIB, o1132.06 06/03/03 02:37:41 [10/9/11 15:26:41]
# 
# Licensed Materials - Property of IBM
# 
# "Restricted Materials of IBM"
# 
# 5724-I63, 5724-H88, 5655-N02, 5733-W70
# 
# (C) Copyright IBM Corp. 2004, 2006 All Rights Reserved.
# 
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with
# IBM Corp.
# @end_restricted_prolog@

progDir=`dirname $0`
workingDir=`pwd`
cd ${progDir}/../bin
. ./setupCmdLine.sh
cd ${workingDir}

if [ ! "$USER_INSTALL_ROOT" ]; then
  USER_INSTALL_ROOT=$WAS_HOME
fi

# Platform specific args
PLATFORM=`/bin/uname`
case ${PLATFORM} in
  AIX | Linux | SunOS | HP-UX)
    CONSOLE_ENCODING='-Dws.output.encoding=console'
    ;;
  OS/390)
    EXTRA_D_ARGS="-Dfile.encoding=ISO8859-1 -Djava.ext.dirs=${JAVA_EXT_DIRS}"
    EXTRA_X_ARGS='-Xnoargsconversion'
    ;;
esac

"$JAVA_HOME/bin/java" \
  -Xbootclasspath/p:"$WAS_BOOTCLASSPATH" \
  $EXTRA_X_ARGS \
  $CONSOLE_ENCODING \
  $WAS_LOGGING \
  -Dwas.install.root="$WAS_HOME" \
  -Duser.install.root="$USER_INSTALL_ROOT" \
  -Dwas.repository.root="$CONFIG_ROOT" \
  -Dlocal.cell="$WAS_CELL" \
  -Dlocal.node="$WAS_NODE" \
  -Dcom.ibm.ws.management.standalone=true \
  -Dcom.ibm.SSL.ConfigURL="file:$USER_INSTALL_ROOT/properties/ssl.client.props" \
  -Dcom.ibm.itp.location="$WAS_HOME/bin" \
  -Dws.ext.dirs="$WAS_EXT_DIRS" \
  $EXTRA_D_ARGS \
  -classpath "$WAS_CLASSPATH" com.ibm.ws.bootstrap.WSLauncher \
  com.ibm.ws.sib.webservices.wsgw.Migrate "$@"

exit $?
